_G.CameraDetectionIcon = _G.CameraDetectionIcon or {}
CameraDetectionIcon.settings = CameraDetectionIcon.settings or {}
local OptionPath = SavePath.."CameraDetectionIcon_Options.txt"
local ModPath = ModPath
local selecting
function CameraDetectionIcon:load()
	CameraDetectionIcon.settings = {}
	local optionsFile = io.open(OptionPath, 'r')
	if optionsFile then
		for key, value in pairs(json.decode(optionsFile:read('*all'))) do
			CameraDetectionIcon.settings[key] = value
		end
		optionsFile:close()
	else
		CameraDetectionIcon:reset()
	end
end

function CameraDetectionIcon:save()
	local optionsFile = io.open(OptionPath, 'w+')
	if optionsFile then
		optionsFile:write(json.encode(CameraDetectionIcon.settings))
		optionsFile:close()
	end
end

function CameraDetectionIcon:reset()
	CameraDetectionIcon.settings.susColorRGB = {R = 255, G = 165, B = 44}
	CameraDetectionIcon.settings.detectedColorRGB = {R = 200, G = 0, B = 0}
end



Hooks:Add('LocalizationManagerPostInit', 'LocalizationManagerPostInit_CameraDetectionIcon', function(loc)
	local language
	for _, filename in pairs(file.GetFiles(ModPath .. 'loc/')) do
		local str = filename:match('^(.*).txt$')
		if str and Idstring(str) and Idstring(str):key() == SystemInfo:language():key() then
			language = filename
			break
		end
	end

	if language then
		loc:load_localization_file(ModPath .. 'loc/' .. language)
	end
	loc:load_localization_file(ModPath .. 'loc/english.txt', false)
end)

Hooks:Add('MenuManagerInitialize', 'MenuManagerInitialize_CameraDetectionIcon', function(menu_manager)
	MenuCallbackHandler.CDIOptionsFocusChanged = function(_, focus)
		local menu = MenuHelper:GetMenu("cdi_options_color_settings")
		local r = menu:item('cdi_options_color_r')
		local g = menu:item('cdi_options_color_g')
		local b = menu:item('cdi_options_color_b')
		local focusingSetting = selecting and CameraDetectionIcon.settings[selecting]
		if focus then
			if not (r and b and g) then return end
			r:set_value(selecting and focusingSetting.R or 0)
			g:set_value(selecting and focusingSetting.G or 0)
			b:set_value(selecting and focusingSetting.B or 0)
		elseif selecting then
			if not (r and b and g) then selecting = nil; return end
			CameraDetectionIcon.settings[selecting] = {R = r:value(), G = g:value(), B = b:value()}
			selecting = nil
		end
	end


	MenuCallbackHandler.CDISusOptions = function()
		managers.menu:open_node("cdi_options_color_settings")
		selecting = "susColorRGB"
	end

	MenuCallbackHandler.CDIDetectedOptions = function()
		managers.menu:open_node("cdi_options_color_settings")
		selecting = "detectedColorRGB"
	end

	MenuCallbackHandler.CDIOptionsSaved = function()
		CameraDetectionIcon:save()
	end

	CameraDetectionIcon:load()
	MenuHelper:LoadFromJsonFile(ModPath.."options/option.txt", CameraDetectionIcon, CameraDetectionIcon.settings)
	MenuHelper:LoadFromJsonFile(ModPath.."options/colorsetting.txt", CameraDetectionIcon, CameraDetectionIcon.settings)
end)

